package bytecode;

import static org.junit.Assert.*;

import java.io.File;
import java.lang.reflect.Field;

import org.junit.BeforeClass;
import org.junit.Test;
import java.net.URL;
import java.net.URLClassLoader;

import de.dhbwstuttgart.core.JavaTXCompiler;

public class FieldTest {
	
	private static String path;
	private static File fileToTest;
	private static JavaTXCompiler compiler;
	private static ClassLoader loader;
	private static Class<?> classToTest;
	private static String pathToClassFile;
	private static Object instanceOfClass;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		path = System.getProperty("user.dir")+"/src/test/resources/bytecode/javFiles/Field.jav";
		fileToTest = new File(path);
		compiler = new JavaTXCompiler(fileToTest);
		compiler.generateBytecode(System.getProperty("user.dir")+"/src/test/resources/testBytecode/generatedBC/");
		pathToClassFile = System.getProperty("user.dir")+"/src/test/resources/testBytecode/generatedBC/";
		loader = new URLClassLoader(new URL[] {new URL("file://"+pathToClassFile)});
		classToTest = loader.loadClass("Field");
		instanceOfClass = classToTest.getDeclaredConstructor().newInstance();
	}

	@Test
	public void test() {
		Field[] fields = classToTest.getFields();
		assertEquals(1, fields.length);
	}

}
